<?php

/*
IMPORTANT: RUN THIS SCRIPT IN A COMMAND-LINE CONSOLE.
*/

require_once('simple_html_dom.php');

$db = mysqli_connect('localhost', 'root', 'root', 'rasekhoon');
mysqli_query($db, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

$gharies = mysqli_query($db, "SELECT * FROM `gharies`");
while ($ghari = mysqli_fetch_assoc($gharies)) {

    echo "\n================================================================================\nGhari {$ghari['id']}\n\n";
    $result = array();
    $i = 0;
    $try = 0;
    $results_count_one = count($result);

    // Make sure all items fetched
    for ($j = 1; $j < 9999; $j++) {
        echo "Loop {$j} started...\n";
        $results_count_two = count($result);
        $html = file_get_html("{$ghari['link']}page{$j}/");

        if (is_null($html) || empty($html)) {
            if ($try <= 99) {
                $try++;
                echo "Try {$try} on Loop {$j}...\n";
                $j--;
                continue;
            } else {
                echo "Failed on Loop {$j}! :(\n";
                continue;
            }
        }

        foreach ($html->find('table.basket tr') as $item) {

            // Break on no result
            if (is_null($item) || empty($item)) {
                echo "Empty on Loop {$j}.\n";
                break 2;
            }

            // Link
            foreach ($item->find('td[align="center"] a') as $tmp) {
                $result[$i]['link'] = 'http://rasekhoon.net/' . urlencode($tmp->href);
            }

            // Title
            foreach ($item->find('td[valign="top"] a b') as $tmp) {
                $result[$i]['title'] = $tmp->innertext();
            }

            // Duration
            foreach ($item->find('td.txt-center span.rich-subtitle b') as $tmp) {
                $result[$i]['duration'] = $tmp->innertext();
            }

            $i++;

        }

        if (count($result) == $results_count_two) {
            $ghari_items = count($result) - $results_count_one;
            $requests_count = $j - 1;
            echo "{$ghari_items} items fetched in {$requests_count} request(s).\n";
            break;
        }

    }

    foreach ($result as $item) {
        $link = mysqli_real_escape_string($db, $item['link']);
        $title = mysqli_real_escape_string($db, $item['title']);
        $duration = mysqli_real_escape_string($db, $item['duration']);
        $insert = mysqli_query($db, "INSERT INTO `ghari_items` (`ghari_id`, `title`, `duration`, `link`, `status`) VALUES ({$ghari['id']}, '{$title}', '{$duration}', '{$link}', 1)");
        if (!$insert) {
            echo "Error! (" . mysqli_errno($db) . ")" . mysqli_error($db) . "\n";
            exit;
        }

    }
    echo "Done! :)\n";

}
